IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_LOTE_SISTEMA' AND
                   TYPE = 'TR' 		 AND
	          U.UID = O.UID          AND
	         U.NAME = USER)
DROP TRIGGER LOG_GER_LOTE_SISTEMA
GO


CREATE  TRIGGER LOG_GER_LOTE_SISTEMA
ON LOTE
FOR INSERT,UPDATE,DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE  @V_DTOPER    DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE @V_ID_COMANDO        VARCHAR(1);
   DECLARE @V_CDFILIAL_OLD	VARCHAR(4);
   DECLARE @V_NRLOTEESTQ_OLD    VARCHAR(20);
   DECLARE @V_NRSUBLOTE_OLD     VARCHAR(4);
   DECLARE @V_CDPRODUTO_OLD	VARCHAR(10);
   DECLARE @V_IDSTATLOTE_OLD	VARCHAR(1);
   DECLARE @V_DTREALIBLOTE_OLD  DATETIME;
   DECLARE @V_DTVALILOTE_OLD    DATETIME;
   DECLARE @V_IDSTANALISE_OLD	VARCHAR(1);
   DECLARE @V_DTVALANALOTE_OLD  DATETIME;
   DECLARE @V_DTFABRPROD_OLD	DATETIME;
   DECLARE @V_CDORDENALOTE_OLD  VARCHAR(20);

   DECLARE @V_CDFILIAL_NEW	VARCHAR(4);
   DECLARE @V_NRLOTEESTQ_NEW	VARCHAR(20);
   DECLARE @V_NRSUBLOTE_NEW	VARCHAR(4);
   DECLARE @V_CDPRODUTO_NEW	VARCHAR(10);
   DECLARE @V_IDSTATLOTE_NEW	VARCHAR(1);
   DECLARE @V_DTREALIBLOTE_NEW	DATETIME;
   DECLARE @V_DTVALILOTE_NEW	DATETIME;
   DECLARE @V_IDSTANALISE_NEW	VARCHAR(1);
   DECLARE @V_DTVALANALOTE_NEW	DATETIME;
   DECLARE @V_DTFABRPROD_NEW	DATETIME;
   DECLARE @V_CDORDENALOTE_NEW	VARCHAR(20);

BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');

   DECLARE C_CURSOR CURSOR FOR

      SELECT
         'U' IDCOMANDO,
      DELETED.CDFILIAL,
      DELETED.NRLOTEESTQ,
      DELETED.NRSUBLOTE,
      DELETED.CDPRODUTO,
      DELETED.IDSTATLOTE,
      DELETED.DTREALIBLOTE,
      DELETED.DTVALILOTE,
      DELETED.IDSTANALISE,
      DELETED.DTVALANALOTE,
      DELETED.DTFABRPROD,
      DELETED.CDORDENALOTE,
      INSERTED.CDFILIAL,
      INSERTED.NRLOTEESTQ,
      INSERTED.NRSUBLOTE,
      INSERTED.CDPRODUTO,
      INSERTED.IDSTATLOTE,
      INSERTED.DTREALIBLOTE,
      INSERTED.DTVALILOTE,
      INSERTED.IDSTANALISE,
      INSERTED.DTVALANALOTE,
      INSERTED.DTFABRPROD,
      INSERTED.CDORDENALOTE

   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDFILIAL   = DELETED.CDFILIAL   AND
      INSERTED.NRLOTEESTQ = DELETED.NRLOTEESTQ AND
      INSERTED.NRSUBLOTE  = DELETED.NRSUBLOTE  AND
      INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

   UNION ALL

   SELECT
      'I' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,

      INSERTED.CDFILIAL,
      INSERTED.NRLOTEESTQ,
      INSERTED.NRSUBLOTE,
      INSERTED.CDPRODUTO,
      INSERTED.IDSTATLOTE,
      INSERTED.DTREALIBLOTE,
      INSERTED.DTVALILOTE,
      INSERTED.IDSTANALISE,
      INSERTED.DTVALANALOTE,
      INSERTED.DTFABRPROD,
      INSERTED.CDORDENALOTE

   FROM
      INSERTED
   WHERE
      CDFILIAL+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO NOT IN (SELECT  CDFILIAL+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO FROM DELETED)


    UNION ALL

    SELECT
	'D' IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,

      DELETED.CDFILIAL,
      DELETED.NRLOTEESTQ,
      DELETED.NRSUBLOTE,
      DELETED.CDPRODUTO,
      DELETED.IDSTATLOTE,
      DELETED.DTREALIBLOTE,
      DELETED.DTVALILOTE,
      DELETED.IDSTANALISE,
      DELETED.DTVALANALOTE,
      DELETED.DTFABRPROD,
      DELETED.CDORDENALOTE

   FROM
      DELETED
   WHERE
      CDFILIAL+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO NOT IN (SELECT  CDFILIAL+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO FROM INSERTED);


   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				 @V_CDFILIAL_OLD,
			   	 @V_NRLOTEESTQ_OLD,
			   	 @V_NRSUBLOTE_OLD,
			   	 @V_CDPRODUTO_OLD,
			   	 @V_IDSTATLOTE_OLD,
			   	 @V_DTREALIBLOTE_OLD,
			   	 @V_DTVALILOTE_OLD,
			   	 @V_IDSTANALISE_OLD,
			   	 @V_DTVALANALOTE_OLD,
			   	 @V_DTFABRPROD_OLD,
			   	 @V_CDORDENALOTE_OLD,
				 @V_CDFILIAL_NEW,
			   	 @V_NRLOTEESTQ_NEW,
			   	 @V_NRSUBLOTE_NEW,
			   	 @V_CDPRODUTO_NEW,
			   	 @V_IDSTATLOTE_NEW,
			   	 @V_DTREALIBLOTE_NEW,
			   	 @V_DTVALILOTE_NEW,
			   	 @V_IDSTANALISE_NEW,
			   	 @V_DTVALANALOTE_NEW,
			   	 @V_DTFABRPROD_NEW,
			   	 @V_CDORDENALOTE_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO = 'D' /*DELETING*/ BEGIN
            SET @V_TIPO = '3';

            IF @V_CDFILIAL_OLD <> ' ' BEGIN
              SET @V_DESC = @V_DESC + 'CodFilial=' + @V_CDFILIAL_OLD;
            END;

            IF @V_NRLOTEESTQ_OLD <> ' ' BEGIN
              SET @V_DESC = @V_DESC + ' NumLotEs=' + @V_NRLOTEESTQ_OLD;
            END;

            IF @V_NRSUBLOTE_OLD <> ' ' BEGIN
              SET @V_DESC = @V_DESC + ' NumSubLo=' + @V_NRSUBLOTE_OLD;
            END;

            IF @V_CDPRODUTO_OLD <> ' ' BEGIN
              SET @V_DESC = @V_DESC + ' CodProd=' + @V_CDPRODUTO_OLD;
            END;

            IF @V_IDSTATLOTE_OLD <> ' ' BEGIN
               SET @V_DESC = @V_DESC + ' IdStatus=' + @V_IDSTATLOTE_OLD;
            END;

            IF @V_DTREALIBLOTE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtRealLi=' + CONVERT(VARCHAR,@V_DTREALIBLOTE_OLD);
            END;

            IF @V_DTVALILOTE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtValiLo=' + CONVERT(VARCHAR,@V_DTVALILOTE_OLD);
            END;

            IF @V_IDSTANALISE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' IdSitAna=' + @V_IDSTANALISE_OLD;
            END;

            IF @V_DTVALANALOTE_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' DtValAna=' + CONVERT(VARCHAR,@V_DTVALANALOTE_OLD);
            END;

            IF @V_DTFABRPROD_OLD <> '30/12/1899' BEGIN
               SET @V_DESC = @V_DESC + ' DtFabPro=' + CONVERT(VARCHAR,@V_DTFABRPROD_OLD);
            END;

            IF @V_CDORDENALOTE_OLD <> ' ' BEGIN
               SET @V_DESC = @V_DESC + ' CdOrdena=' + @V_CDORDENALOTE_OLD;
            END;

            SET @V_ITPESQ = @V_CDFILIAL_OLD 	+ 
			    @V_NRLOTEESTQ_OLD 	+ 
			    @V_NRSUBLOTE_OLD 	+ 
                            @V_CDPRODUTO_OLD;
        END
        ELSE

        IF @V_ID_COMANDO = 'U' /*UPDATING*/ BEGIN

           IF (@V_CDFILIAL_OLD     <> @V_CDFILIAL_NEW)     OR
              (@V_NRLOTEESTQ_OLD   <> @V_NRLOTEESTQ_NEW)   OR
              (@V_NRSUBLOTE_OLD    <> @V_NRSUBLOTE_NEW)    OR
              (@V_CDPRODUTO_OLD    <> @V_CDPRODUTO_NEW)    OR
              (@V_IDSTATLOTE_OLD   <> @V_IDSTATLOTE_NEW)   OR
              (@V_DTREALIBLOTE_OLD <> @V_DTREALIBLOTE_NEW) OR
              (@V_DTVALILOTE_OLD   <> @V_DTVALILOTE_NEW)   OR
              (@V_IDSTANALISE_OLD  <> @V_IDSTANALISE_NEW)  OR
              (@V_DTVALANALOTE_OLD <> @V_DTVALANALOTE_NEW) OR
              (@V_DTFABRPROD_OLD   <> @V_DTFABRPROD_NEW)   OR
              (@V_CDORDENALOTE_OLD <> @V_CDORDENALOTE_NEW) BEGIN

              SET  @V_TIPO   = '2';
              SET  @V_ITPESQ = @V_CDFILIAL_OLD	   +
			       @V_NRLOTEESTQ_OLD   +
			       @V_NRSUBLOTE_OLD    +
			       @V_CDPRODUTO_OLD;
           END;
        END
        ELSE
           SET @V_TIPO   = '1';
           SET @V_ITPESQ = @V_CDFILIAL_NEW     +
                           @V_NRLOTEESTQ_NEW   +
                           @V_NRSUBLOTE_NEW    +
			   @V_CDPRODUTO_NEW;
        END;

      IF @V_CDFILIAL_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + 'CodFilial=' + @V_CDFILIAL_NEW;
      END;

      IF @V_NRLOTEESTQ_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' NumLotEs=' + @V_NRLOTEESTQ_NEW;
      END;

      IF @V_NRSUBLOTE_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' NumSubLo=' + @V_NRSUBLOTE_NEW;
      END;

      IF @V_CDPRODUTO_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' CodProd=' + @V_CDPRODUTO_NEW;
      END;

      IF @V_IDSTATLOTE_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' IdStatus=' + @V_IDSTATLOTE_NEW;
      END;

      IF @V_DTREALIBLOTE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtRealLi=' + CONVERT(VARCHAR,@V_DTREALIBLOTE_NEW);
      END;

      IF @V_DTVALILOTE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtValiLo=' + CONVERT(VARCHAR,@V_DTVALILOTE_NEW);
      END;

      IF @V_IDSTANALISE_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' IdSitAna=' + @V_IDSTANALISE_NEW;
      END;

      IF @V_DTVALANALOTE_NEW IS NOT NULL BEGIN
         SET @V_DESC = @V_DESC + ' DtValAna=' + CONVERT(VARCHAR,@V_DTVALANALOTE_NEW);
      END;

      IF @V_DTFABRPROD_NEW <> '30/12/1899' BEGIN
         SET @V_DESC = @V_DESC + ' DtFabPro=' + CONVERT(VARCHAR,@V_DTFABRPROD_NEW);
      END;

      IF @V_CDORDENALOTE_NEW <> ' ' BEGIN
         SET @V_DESC = @V_DESC + ' CdOrdena=' + @V_CDORDENALOTE_NEW;
      END;

      IF (@V_TIPO <> '0')  BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            EXEC NMUSUARIO @V_USUARIO;	
            SET  @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA
                     (  NMTABELA, DTOPERACAO, NMRESPOPER,
                        IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                     ('LOTE', @V_DTOPER, @V_USUARIO,
                        @V_TIPO,    @V_ITPESQ, @V_DESC);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
				    @V_CDFILIAL_OLD,
	                            @V_NRLOTEESTQ_OLD,
			   	    @V_NRSUBLOTE_OLD,
			   	    @V_CDPRODUTO_OLD,
			   	    @V_IDSTATLOTE_OLD,
			   	    @V_DTREALIBLOTE_OLD,
			   	    @V_DTVALILOTE_OLD,
			   	    @V_IDSTANALISE_OLD,
			   	    @V_DTVALANALOTE_OLD,
			   	    @V_DTFABRPROD_OLD,
			   	    @V_CDORDENALOTE_OLD,
				    @V_CDFILIAL_NEW,
			   	    @V_NRLOTEESTQ_NEW,
			   	    @V_NRSUBLOTE_NEW,
			   	    @V_CDPRODUTO_NEW,
			   	    @V_IDSTATLOTE_NEW,
			   	    @V_DTREALIBLOTE_NEW,
			   	    @V_DTVALILOTE_NEW,
			   	    @V_IDSTANALISE_NEW,
			   	    @V_DTVALANALOTE_NEW,
			   	    @V_DTFABRPROD_NEW,
			   	    @V_CDORDENALOTE_NEW;
      END;              
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_LOTE_SISTEMA','5.01.001';
GO

